// Ex11_02

color[] minard = {#262626, 
  #F4FF52, 
  #96E072 , 
  #ABFF4F, 
  #FF9914, 
  #F21B3F, 
  #26F0F1, 
  #FAF33E, 
  #FFFFFF};
color[] palette = minard;
PFont labelFont;
PFont legendFont;

Table stateData;
int rowCount;
int d = 10;
int dGrading = 4;

//modul typ
String str1 = "lect";
String str2 = "workshop";
String str3 = "sem";
String str4 = "block";
String str5 = "constrMod";
String str6 = "wissMod";
String str7 = "sglMod";
String str8 = "projMod";

//location
String str01 = "Marienstraße 1";
String str02 = "Marienstraße 7 B";
String str03 = "Marienstraße 14";
String str04 = "Geschwister-Scholl-Straße 7";
String str05 = "Geschwister-Scholl-Straße 8A";
String str06 = "Geschwister-Scholl-Straße 13";
String str07 = "Steubenstraße 6a";
String str08 = "Steubenstraße 8";
String str09 = "Bauhausstraße 11";
String str010 = "Bauhausstraße 15";
String str011 = "Coudraystraße 13";
String str012 = "Trierer Straße 12";
String str013 = "Scherfgasse 5";

//grading strings
String str001 = "Teilnahme";
String str002 = "Aufgaben";
String str003 = "Belegarbeit";
String str004 = "Referat";
String str005 = "Projektabgabe";
String str006 = "Ausstellung";
String str007 = "Aufsatz";
String str008 = "Aufführung";

String str009 =  "Belegarbeit, Referat";
String str0010 = "Teilnahme, Belegarbeit, Projektabgabe";
String str0011 = "Teilnahme, Aufgaben, Belegarbeit, Projektabgabe";
String str0012 = "Referat, Aufgaben";
String str0013 = "Teilnahme, Aufsatz";
String str0014 = "Belegarbeit, Projektabgabe";
String str0015 = "Referat, Projektabgabe";
String str0016 = "Teilnahme, Projektabgabe, Ausstellung";
String str0017 = "Projektabgabe, Austellung";
String str0018 = "Referat, Belegarbeit, Projektabgabe";
String str0019 = "Teilnahme, Projektabgabe";
String str0020 = "Aufführung, Aufsatz";

void setup() {
  size(1000, 780);
  stateData = new Table("stateData-4.tsv");
  rowCount = stateData.getRowCount();
  println("rowCount = " + rowCount);
  labelFont = loadFont("FiraSans-Regular-12.vlw");
  legendFont = loadFont("FiraSans-Regular-8.vlw");
  smooth();
}

void draw() {
  background(palette[0]);
  textFont(labelFont);
  stroke(80);
  fill(180);

  // Line and labels for X axis
  textAlign(CENTER);
  line(100, 600, 900, 600);
  for (int i = 0; i < 5; i++) {
    line(i * 200 + 100, 50, i * 200 + 100, 600);
  }
  
  text ("18", 800, 620);
  text ("6", 600, 620);
  text ("3", 400, 620);
  text ("0", 200, 620);
  text("ECTS", 960, 620);

  // Line and labels for Y axis
  textAlign(RIGHT);
  line(100, 50, 100, 600);
  for (int i = 0; i < 4; i++) {
    line(100, 400-i*175, 900, 400-i*175);
    //text (i-3, 95, 400-i*110);
  }
  
  pushMatrix();
  translate(0,140);
  rotate(-HALF_PI);
    text("bilingual", 20, 80);
  popMatrix();
  
  pushMatrix();
  translate(0,380);
  rotate(-HALF_PI); 
    text("english", 95, 80);
  popMatrix();
  
  pushMatrix();
  translate(0,380);
  rotate(-HALF_PI); 
    text("german", -100, 80);
  popMatrix();

  pushMatrix();
  translate(0,380);
  rotate(-HALF_PI); 
    text("language", 360, 80);
  popMatrix();


  // Gets data, draws dots
  for (int row = 0; row < rowCount; row++) {
    // grading
    String grading = stateData.getString(row, 7);
    
    // Course names
    String course = stateData.getString(row, 2);

    // ects
    float ects = stateData.getFloat(row, 0);
    float x = map(ects, 0, 104, 100, 900);

    // language
    float language = stateData.getFloat(row, 1);
    float y = map(language, 0, 4, 100, 600);

    // modul type  
    String modTyp = stateData.getString(row, 4);
    
    color c = #FFBA00;
    if (str1.equals(modTyp) == true) {
      c = minard[1];
    } else if (str2.equals(modTyp) == true) {
      c = minard[2];
    } else if (str3.equals(modTyp) == true) {
      c = minard[3];
    } else if (str4.equals(modTyp) == true) {
      c = minard[4];
    } else if (str5.equals(modTyp) == true) {
      c = minard[5];
    } else if (str6.equals(modTyp) == true) {
      c = minard[6];
    } else if (str7.equals(modTyp) == true) {
      c = minard[7];
    } else if (str8.equals(modTyp) == true) {
      c = minard[8];
    }
    
    fill(palette[0]);
    stroke(c, 180);
    
    //String str001 = "Teilnahme";
      if (str001.equals(grading) == true) {
        line(x-14, y-14, x+14, y+14);
        line(x-14, y+14, x+14, y-14);
      } 
    //String str002 = "Aufgaben";     
      if (str002.equals(grading) == true) {
        line(x, y, x-14, y);
      } 
    //String str003 = "Belegarbeit";      
      if (str003.equals(grading) == true) {
        line(x, y, x+14, y);
      }
     //String str004 = "Referat";
      if (str004.equals(grading) == true) {
        line(x, y, x-14, y-14);
        ellipse(x-14, y-14, dGrading, dGrading);
      }
      //String str005 = "Projektabgabe";
      if (str005.equals(grading) == true) {
        line(x, y, x+14, y-14);
        ellipse(x+14, y-14, dGrading, dGrading);
      }
    //String str006 = "Ausstellung";
      if (str006.equals(grading) == true) {
        line(x, y, x-14, y+14);
        ellipse(x-14, y+14, dGrading, dGrading);
      }
     //String str007 = "Aufsatz";
      if (str007.equals(grading) == true) {
        line(x, y, x+14, y+14);
        ellipse(x+14, y+14, dGrading, dGrading);
      }   
    //String str008 = "Aufführung";
      if (str008.equals(grading) == true) {
        line(x, y, x, y-18);
      }     
    //String str009 =  "Belegarbeit, Referat";
       if (str009.equals(grading) == true) {
        line(x, y, x+14, y);
        
        line(x, y, x-14, y-14);
        ellipse(x-14, y-14, dGrading, dGrading);
      }
    //String str0010 = "Teilnahme, Belegarbeit, Projektabgabe";
       if (str0010.equals(grading) == true) {
        line(x-14, y-14, x+14, y+14);
        line(x-14, y+14, x+14, y-14);
        
        line(x, y, x+14, y);
        
        line(x, y, x+14, y-14);
        ellipse(x+14, y-14, dGrading, dGrading);
      }    
    //String str0011 = "Teilnahme, Aufgaben, Belegarbeit, Projektabgabe";
    if (str0011.equals(grading) == true) {
        line(x-14, y-14, x+14, y+14);
        line(x-14, y+14, x+14, y-14);
        
        line(x, y, x-14, y);
        
        line(x, y, x+14, y);
        
        line(x, y, x+14, y-14);
        ellipse(x+14, y-14, dGrading, dGrading);
      }    
    //String str0012 = "Referat, Aufgaben";
    if (str0012.equals(grading) == true) {
        line(x, y, x-14, y-14);
        ellipse(x-14, y-14, dGrading, dGrading);
        
        line(x, y, x-14, y);
      }
    //String str0013 = "Teilnahme, Aufsatz";
    if (str0013.equals(grading) == true) {
        line(x-14, y-14, x+14, y+14);
        line(x-14, y+14, x+14, y-14);
        
        line(x, y, x+14, y+14);
        ellipse(x+14, y+14, dGrading, dGrading);
      }    
    //String str0014 = "Belegarbeit, Projektabgabe";
    if (str0014.equals(grading) == true) {
        line(x, y, x+14, y);
        
        line(x, y, x+14, y-14);
        ellipse(x+14, y-14, dGrading, dGrading);
      }      
    //String str0015 = "Referat, Projektabgabe";
    if (str0015.equals(grading) == true) {
        line(x, y, x-14, y-14);
        ellipse(x-14, y-14, dGrading, dGrading);
        
        line(x, y, x+14, y-14);
        ellipse(x+14, y-14, dGrading, dGrading);
      }    
    //String str0016 = "Teilnahme, Projektabgabe, Ausstellung";
    if (str0016.equals(grading) == true) {
        line(x-14, y-14, x+14, y+14);
        line(x-14, y+14, x+14, y-14);
        
        line(x, y, x+14, y-14);
        ellipse(x+14, y-14, dGrading, dGrading);
        
        line(x, y, x-14, y+14);
        ellipse(x-14, y+14, dGrading, dGrading);
      }     
    //String str0017 = "Projektabgabe, Austellung";
    if (str0017.equals(grading) == true) {
        line(x, y, x+14, y-14);
        ellipse(x+14, y-14, dGrading, dGrading);
        
        line(x, y, x-14, y+14);
        ellipse(x-14, y+14, dGrading, dGrading);
      } 
    //String str0018 = "Referat, Belegarbeit, Projektabgabe";
    if (str0018.equals(grading) == true) {
        line(x, y, x-14, y-14);
        ellipse(x-14, y-14, dGrading, dGrading);
      
        line(x, y, x+14, y);
      
        line(x, y, x+14, y-14);
        ellipse(x+14, y-14, dGrading, dGrading);
      }    
    //String str0019 = "Teilnahme, Projektabgabe";
    if (str0019.equals(grading) == true) {
        line(x-14, y-14, x+14, y+14);
        line(x-14, y+14, x+14, y-14);
      
        line(x, y, x+14, y-14);
        ellipse(x+14, y-14, dGrading, dGrading);
      }     
    //String str0020 = "Aufführung, Aufsatz";
    if (str0020.equals(grading) == true) {
        line(x, y, x, y-18);
        
        line(x, y, x+14, y+14);
        ellipse(x+14, y+14, dGrading, dGrading);
      }  
      
    //location
    String local = stateData.getString(row, 6);
    
    //triangle coordinates
    float x1 = x-6.5;
    float y1 = y+13;
    float x2 = x+6.5;
    float y2 = y+6.5;
    
    float x01 = x-3;
    float x02 = x+3;
    float y03 = y+9;
    float y01 = y+3;
    float y02 = y+6;
    
    if (str01.equals(local) == true) {
      rect(x,y,d,d);
    } else if (str02.equals(local) == true) {
      rectMode(CENTER);
      rect(x,y,d,d);
      rect(x,y,d/2.5,d/2.5);
    } else if (str03.equals(local) == true) {
      rectMode(CENTER);
      rect(x,y,d,d);
      fill(c, 180);
      rect(x,y,d/2.5,d/2.5);
    } else if (str04.equals(local) == true) {
      ellipse(x, y, d, d);
    }  else if (str05.equals(local) == true) {
      ellipseMode(CENTER);
      ellipse(x,y,d,d);
      ellipse(x, y, d/2.5, d/2.5);
    } else if (str06.equals(local) == true) {
      ellipseMode(CENTER);
      ellipse(x,y,d,d);
      fill(c, 180);
      ellipse(x, y, d/2.5, d/2.5);
    } else if (str07.equals(local) == true) {
        pushMatrix();
        polygon(x, y, 8, 3);
        popMatrix();
    } else if (str08.equals(local) == true) {
        pushMatrix();
        polygon(x, y, 8, 3);
        popMatrix();
        
        pushMatrix();
        polygon(x, y, 2, 3);
        popMatrix();
    } else if (str09.equals(local) == true) {
        pushMatrix();
        polygon(x, y, 6, 3);
        popMatrix();
    } else if (str010.equals(local) == true) {
      beginShape();
        vertex(x,y+7);
        vertex(x+7,y);
        vertex(x,y-7);
        vertex(x-7,y);
      endShape(CLOSE);
      
      beginShape();
        vertex(x,y+3);
        vertex(x+3,y);
        vertex(x,y-3);
        vertex(x-3,y);
      endShape(CLOSE);
    } else if (str011.equals(local) == true) {
        pushMatrix();
        polygon(x, y, 6, 5);
        popMatrix();
    } else if (str012.equals(local) == true) {
        pushMatrix();
        polygon(x, y, 6, 6);
        popMatrix();
    } else if (str013.equals(local) == true) {
        pushMatrix();
        polygon(x, y, 6, 8);
        popMatrix();
    }
    
    textAlign(LEFT);
    fill(180);
    if (dist(x, y, mouseX, mouseY) < (d/2+2)) {
      text(course, x, y - 10);
    }
  }
  
   // legends
   float LegLocation = 60;
   float colLegRow = 45;
   float colLegCol = 640;
   float colLegCol2 = 695;
   
    float LegLocationGrade = 480 + colLegRow;
   
   for (int i = 0; i < 8; i++) {
      fill(minard[1+i]);
      noStroke();
      rect(105 + colLegRow * i, colLegCol, d, d);       
   }
   textFont(legendFont);
   text("projektmodul  werkmodul  fachmodul   wiss modul      seminar    vorlesung     workshop        block",
   75, 665);
   
   stroke(180);
   fill(180);
   
   
   line((LegLocationGrade) - 7, colLegCol - 7, (LegLocationGrade) + 7, colLegCol + 7);
   line((LegLocationGrade) - 7, colLegCol + 7, (LegLocationGrade) + 7, colLegCol - 7);
   
   line(LegLocationGrade , colLegCol, (LegLocationGrade) - 10, colLegCol);
   
   line(LegLocationGrade, colLegCol, (LegLocationGrade) + 10, colLegCol);
   
   line((LegLocationGrade), colLegCol, (LegLocationGrade) - 7, colLegCol - 7);
   ellipse((LegLocationGrade) - 7, colLegCol - 7, dGrading, dGrading);
   
   line((LegLocationGrade), colLegCol, (LegLocationGrade) + 7, colLegCol - 7);
   ellipse((LegLocationGrade) + 7, colLegCol - 7, dGrading, dGrading);
   
   line((LegLocationGrade), colLegCol, (LegLocationGrade) - 7, colLegCol + 7);
   ellipse((LegLocationGrade) - 7, colLegCol + 7, dGrading, dGrading);
   
   line((LegLocationGrade), colLegCol, (LegLocationGrade) + 7, colLegCol + 7);
   ellipse((LegLocationGrade) + 7, colLegCol + 7, dGrading, dGrading);
   
   line(LegLocationGrade, colLegCol, LegLocationGrade, colLegCol - 7);
   
   
   
   //1teilnahme
   line((LegLocationGrade + colLegRow) - 7, colLegCol - 7, (LegLocationGrade + colLegRow) + 7, colLegCol + 7);
   line((LegLocationGrade + colLegRow) - 7, colLegCol + 7, (LegLocationGrade + colLegRow) + 7, colLegCol - 7);
   
   //2aufgaben  
   line(LegLocationGrade + (colLegRow * 2), colLegCol, (LegLocationGrade + (colLegRow * 2) - 10), colLegCol);  
   ellipse(LegLocationGrade + (colLegRow * 2), colLegCol, 2, 2);
   
   //3belegarbeit  
   line(LegLocationGrade + (colLegRow * 3), colLegCol, (LegLocationGrade + (colLegRow * 3)) + 10, colLegCol);
   ellipse(LegLocationGrade + (colLegRow * 3), colLegCol, 2, 2);
   
   //4Referat
   line((LegLocationGrade + (colLegRow * 4)), colLegCol, (LegLocationGrade + (colLegRow * 4)) - 7, colLegCol - 7);
   ellipse((LegLocationGrade + (colLegRow * 4)) - 7, colLegCol - 7, dGrading, dGrading);
   ellipse((LegLocationGrade + (colLegRow * 4)), colLegCol, 2, 2);
   
   //projektabgabe
   line((LegLocationGrade + (colLegRow * 5)), colLegCol, (LegLocationGrade + (colLegRow * 5)) + 7, colLegCol - 7);
   ellipse((LegLocationGrade + (colLegRow * 5)) + 7, colLegCol - 7, dGrading, dGrading);
   ellipse((LegLocationGrade + (colLegRow * 5)), colLegCol, 2, 2);
   
   //austellung
   line((LegLocationGrade + (colLegRow * 6)), colLegCol, (LegLocationGrade + (colLegRow * 6)) - 7, colLegCol + 7);
   ellipse((LegLocationGrade + (colLegRow * 6)) - 7, colLegCol + 7, dGrading, dGrading);
   ellipse((LegLocationGrade + (colLegRow * 6)), colLegCol, 2, 2);
   
   //austellung
   line((LegLocationGrade + (colLegRow * 7)), colLegCol, (LegLocationGrade  + (colLegRow * 7)) - 7, colLegCol + 7);
   ellipse((LegLocationGrade  + (colLegRow * 7)) - 7, colLegCol + 7, dGrading, dGrading);
   ellipse((LegLocationGrade + (colLegRow * 7)), colLegCol, 2, 2);
   
   //aufsatz
   line((LegLocationGrade  + (colLegRow * 8)), colLegCol, (LegLocationGrade  + (colLegRow * 8)) + 7, colLegCol + 7);
   ellipse((LegLocationGrade  + (colLegRow * 8)) + 7, colLegCol + 7, dGrading, dGrading);
   ellipse((LegLocationGrade + (colLegRow * 8)), colLegCol, 2, 2);
   
   text("Teilnahme    Aufgaben    Belegarbeit       Referat     Projektagb.   Ausstellung    Aufsatz    Aufführung", LegLocationGrade+25, 665);
 
   
   
   noFill();
   stroke(180);
   rect(LegLocation + colLegRow * 1, colLegCol2, d, d);
   
   rect(LegLocation + colLegRow * 2, colLegCol2, d, d);
   rect(LegLocation + colLegRow * 2, colLegCol2, d/2.5, d/2.5);
   
   rect(LegLocation + colLegRow * 3, colLegCol2, d, d);
   fill(180);
   rect(LegLocation + colLegRow * 3, colLegCol2, d/2.5, d/2.5);
   
   noFill();
   stroke(180);
   ellipse(LegLocation + colLegRow * 4, colLegCol2, d, d);
   
   ellipse(LegLocation + colLegRow * 5, colLegCol2, d, d);
   ellipse(LegLocation + colLegRow * 5, colLegCol2, d/2.5, d/2.5);
   
   ellipse(LegLocation + colLegRow * 6, colLegCol2, d, d);
   fill(180);
   ellipse(LegLocation + colLegRow * 6, colLegCol2, d/2.5, d/2.5);  
   
   pushMatrix();  
     noFill();
     polygon(LegLocation + colLegRow * 7, colLegCol2, 6, 3);
   popMatrix();
   
   pushMatrix();  
     noFill();
     polygon(LegLocation + colLegRow * 8, colLegCol2, 6, 3);
     polygon(LegLocation + colLegRow * 8, colLegCol2, 2, 3);
   popMatrix();
   
   pushMatrix();  
     noFill();
     polygon(LegLocation + colLegRow * 9, colLegCol2, 6, 4);
   popMatrix();
   
   pushMatrix();  
     noFill();
     polygon(LegLocation + colLegRow * 10, colLegCol2, 6, 4);
     polygon(LegLocation + colLegRow * 10, colLegCol2, 2, 4);
   popMatrix();

  pushMatrix();  
     noFill();
     polygon(LegLocation + colLegRow * 11, colLegCol2, 6, 5);
   popMatrix();
   
   pushMatrix();  
     noFill();
     polygon(LegLocation + colLegRow * 12, colLegCol2, 6, 6);
   popMatrix();
   
   pushMatrix();  
     noFill();
     polygon(LegLocation + colLegRow * 13, colLegCol2, 6, 8);
   popMatrix();
   
   text("Marien 1      Marien 7B      Marien 14        Gesch 7      Gesch 8A      Gesch 13      Steuben 6     Steuben 8     Bauhaus 11   Bauhaus 15   Coudray 13   Trierer 12   Scherfgasse 5", LegLocation+30, 720);
   
}

void polygon(float x, float y, float radius, int npoints) {
  float angle = TWO_PI / npoints;
  beginShape();
  for (float a = 0; a < TWO_PI; a += angle) {
    float sx = x + cos(a) * radius;
    float sy = y + sin(a) * radius;
    vertex(sx, sy);
  }
  endShape(CLOSE);
}
